%global dlrn_nvr vmware-nsxlib-15.2.1.dev1-2.20230417185046.59b1b74
%global dlrn 1
%define upstream_version 15.2.1.dev1
# Macros for py2/py3 compatibility
%if 0%{?fedora} || 0%{?rhel} > 7
%global pyver %{python3_pkgversion}
%else
%global pyver 2
%endif
%global pyver_bin python%{pyver}
%global pyver_sitelib %{expand:%{python%{pyver}_sitelib}}
%global pyver_install %{expand:%{py%{pyver}_install}}
%global pyver_build %{expand:%{py%{pyver}_build}}
# End of macros for py2/py3 compatibility
%{!?upstream_version: %global upstream_version %{version}%{?milestone}}

%global pypi_name vmware-nsxlib
%global module vmware_nsxlib
# oslosphinx do not work with sphinx > 2
%if %{pyver} == 3
%global with_doc 0
%else
%global with_doc 0
%endif

Name:           python-%{pypi_name}
Version: 15.2.1
Release: 2.20230417185046.59b1b74%{?dist}
Summary:        A common library that interfaces with VMware NSX

License:        ASL 2.0
URL:            https://github.com/openstack/vmware-nsxlib
Source0: vmware-nsxlib-15.2.1.dev1-2.20230417185046.59b1b74.tar.gz
#
# patches_ignore=DROP-IN-RPM
# patches_base=59b1b744f5e9a0e48aef4c38311c0062181908c9
Patch0001: 0001-Find-tier0-s-tranzport_zone-via-advanced_config.patch

BuildArch:      noarch

%description
vmware-nsxlib is a common library that interfaces with VMware NSX

%package -n     python%{pyver}-%{pypi_name}
Summary:        A common library that interfaces with VMware NSX
%{?python_provide:%python_provide python%{pyver}-%{pypi_name}}

BuildRequires:  git
BuildRequires:  python%{pyver}-fixtures
BuildRequires:  python%{pyver}-setuptools
BuildRequires:  python%{pyver}-subunit
BuildRequires:  python%{pyver}-stestr
BuildRequires:  python%{pyver}-testscenarios
BuildRequires:  python%{pyver}-testtools
BuildRequires:  python%{pyver}-devel
BuildRequires:  python%{pyver}-hacking
BuildRequires:  python%{pyver}-mock
BuildRequires:  python%{pyver}-oslotest
BuildRequires:  python%{pyver}-oslo-log
BuildRequires:  python%{pyver}-oslo-serialization
BuildRequires:  python%{pyver}-oslo-service
BuildRequires:  python%{pyver}-oslo-utils
BuildRequires:  python%{pyver}-pbr
BuildRequires:  python%{pyver}-sphinx
BuildRequires:  python%{pyver}-tenacity
BuildRequires:  python%{pyver}-testresources
Requires:       python%{pyver}-pbr >= 2.0.0
Requires:       python%{pyver}-eventlet >= 0.18.2
Requires:       python%{pyver}-netaddr >= 0.7.18
Requires:       python%{pyver}-tenacity >= 4.4.0
Requires:       python%{pyver}-six >= 1.10.0
Requires:       python%{pyver}-oslo-i18n >= 3.15.3
Requires:       python%{pyver}-oslo-log >= 3.36.0
Requires:       python%{pyver}-oslo-serialization >= 2.18.0
Requires:       python%{pyver}-oslo-service >= 1.24.0
Requires:       python%{pyver}-oslo-utils >= 3.33.0
Requires:       python%{pyver}-pyOpenSSL >= 17.1.0

# Handle python2 exception
%if %{pyver} == 2
BuildRequires:  python-requests-mock
BuildRequires:  python-decorator
Requires:       python-decorator
Requires:       python-enum34
%else
BuildRequires:  python%{pyver}-requests-mock
BuildRequires:  python%{pyver}-decorator
Requires:       python%{pyver}-decorator
%endif

%description -n python%{pyver}-%{pypi_name}
vmware-nsxlib is a common library that interfaces with VMware NSX


%package -n python%{pyver}-%{pypi_name}-tests
Summary:    A common library that interfaces with VMware NSX - tests
Requires:   python%{pyver}-%{pypi_name} = %{version}-%{release}

%description -n python%{pyver}-%{pypi_name}-tests
A common library that interfaces with VMware NSX

This package contains the test files.


%if 0%{?with_doc}
%package -n python-%{pypi_name}-doc
Summary:        vmware-nsxlib documentation

BuildRequires:  python%{pyver}-oslo-sphinx
BuildRequires:  python%{pyver}-sphinx

%description -n python-%{pypi_name}-doc
Documentation for vmware-nsxlib
%endif


%prep
%autosetup -n %{pypi_name}-%{upstream_version} -S git
# Let's handle dependencies ourseleves
rm -f *requirements.txt
# Remove bundled egg-info
rm -rf %{pypi_name}.egg-info

%build
%{pyver_build}

%if 0%{?with_doc}
# generate html docs
sphinx-build-%{pyver} doc/source html
# remove the sphinx-build-%{pyver} leftovers
rm -rf html/.{doctrees,buildinfo}
%endif

%install
%{pyver_install}

%check
stestr-%{pyver} run

%files -n python%{pyver}-%{pypi_name}
%license LICENSE
%doc README.rst
%{pyver_sitelib}/%{module}
%{pyver_sitelib}/%{module}-*-py?.?.egg-info
%exclude %{pyver_sitelib}/%{module}/tests

%files -n python%{pyver}-%{pypi_name}-tests
%license LICENSE
%{pyver_sitelib}/%{module}/tests

%if 0%{?with_doc}
%files -n python-%{pypi_name}-doc
%license LICENSE
%doc html
%endif

%changelog
* Mon Apr 17 2023 OSP Prod Chain <dev-null@redhat.com> 15.2.1-2.20230417185046.59b1b74
- Update patches
- Tier-1: Retry when removing edge cluster

* Wed Jun 22 2022 OSP Prod Chain <dev-null@redhat.com> 15.1.1-2.20220622154858.624aa52
- Update patches
- zuul: run py37 and pep8 jobs
- Handle response is not a json format
- Drop python2 jobs

* Sat Jun 11 2022 OSP Prod Chain <dev-null@redhat.com> 15.1.1-2.20220611144855.f4fa99e
- Update patches
- [MP] Support firewall_match for NAT rules

* Thu Dec 02 2021 OSP Prod Chain <dev-null@redhat.com> 15.1.1-2.20211202214916.ffc81fe
- Update patches
- Fix typo in exception name

* Tue Oct 26 2021 OSP Prod Chain <dev-null@redhat.com> 15.1.1-2.20211026144931.d4b9c60
- Update patches
- NSX Policy: patch security rules with ChildResourceReference
- NSX policy transaction: Modify retry policy
- Temporarily disable lower constraints job

* Mon Aug 30 2021 OSP Prod Chain <dev-null@redhat.com> 15.1.1-2.20210830144814.dc3570c
- Update patches
- Add MP610 error code to retryable errors

* Fri Aug 27 2021 OSP Prod Chain <dev-null@redhat.com> 15.1.1-2.20210827144818.0272e1e
- Update patches
- Segment: Allow for setting multicast in advanced_config

* Tue Aug 03 2021 OSP Prod Chain <dev-null@redhat.com> 15.1.1-2.20210803144811.d26d79d
- Update patches
- Ignore H216 check
- Add Create identity with cert
- NSX PI: Do not use deprecated API when registering identity

* Fri May 28 2021 OSP Prod Chain <dev-null@redhat.com> 15.1.1-2.20210528104032.3f15e99
- Update patches

* Thu Mar 18 2021 OSP Prod Chain <dev-null@redhat.com> 14.0.3-1
- Update patches
- Fix session persistemce profiles list

* Fri Feb 12 2021 OSP Prod Chain <dev-null@redhat.com> 14.0.3-1
- Update patches
- Add Tier0RouteRedistributionConfig methods

* Thu Jan 28 2021 OSP Prod Chain <dev-null@redhat.com> 14.0.3-1
- Update patches
- Allow removing segment port address bindings

* Mon Jan 11 2021 OSP Prod Chain <dev-null@redhat.com> 14.0.3-1
- Update patches

* Mon Jan 11 2021 OSP Prod Chain <dev-null@redhat.com> 14.0.3-1
- Update patches
- Support segment overlay-id

* Tue Dec 22 2020 OSP Prod Chain <dev-null@redhat.com> 14.0.3-1
- Update patches

* Tue Dec 22 2020 OSP Prod Chain <dev-null@redhat.com> 14.0.3-1
- Update patches
- Skip flake8 warnings

* Thu Dec 17 2020 OSP Prod Chain <dev-null@redhat.com> 14.0.3-1
- Update patches

* Wed Dec 02 2020 OSP Prod Chain <dev-null@redhat.com> 14.0.3-1
- Update patches
- Build entry with a list of plain string as group
- Create entry with a list of plain string as group

* Wed Nov 04 2020 OSP Prod Chain <dev-null@redhat.com> 14.0.3-1
- Update patches
- Add realtime LB service statistics

* Tue Nov 03 2020 OSP Prod Chain <dev-null@redhat.com> 14.0.3-1
- Update patches
- Fix update of the pool member backup state

* Wed Oct 28 2020 OSP Prod Chain <dev-null@redhat.com> 14.0.3-1
- Update patches
- Add stale revision error code

* Tue Oct 27 2020 OSP Prod Chain <dev-null@redhat.com> 14.0.3-1
- Update patches
- Add logging for failed realization

* Fri Oct 16 2020 OSP Prod Chain <dev-null@redhat.com> 14.0.3-1
- Update patches
- Add wait for successful state for segment api

* Wed Oct 14 2020 OSP Prod Chain <dev-null@redhat.com> 14.0.3-1
- Update patches
- Check realization status when getting id by search

* Mon Oct 12 2020 OSP Prod Chain <dev-null@redhat.com> 14.0.3-1
- Update patches
- Use related error codes to decide on the exception
- Use entity-type when checking realization by search api

* Mon Oct 05 2020 OSP Prod Chain <dev-null@redhat.com> 14.0.3-1
- Update patches
- Revert "Stop old validation loops before reinitializing the cluster"
- Add api for nsxlib passthrough object

* Thu Oct 01 2020 OSP Prod Chain <dev-null@redhat.com> 14.0.3-1
- Update patches
- Stop old validation loops before reinitializing the cluster

* Tue Sep 22 2020 OSP Prod Chain <dev-null@redhat.com> 14.0.3-1
- Update patches
- Expose HTTP Status Code in ManagerError

* Thu Sep 17 2020 OSP Prod Chain <dev-null@redhat.com> 14.0.3-1
- Update patches
- Suppress logging of lb services list results if empty

* Tue Sep 15 2020 OSP Prod Chain <dev-null@redhat.com> 14.0.3-1
- Update patches
- Replace 'rn' with 'n' in cert pem before looks for existing ones

* Thu Aug 27 2020 OSP Prod Chain <dev-null@redhat.com> 14.0.3-1
- Update patches
- Add silent flags to LB actions
- Fix ipv6 address pairs limits for ipv6 to 15

* Wed Aug 26 2020 OSP Prod Chain <dev-null@redhat.com> 14.0.3-1
- Update patches
- Add silent flags to LB actions
- Fix ipv6 address pairs limits for ipv6 to 15

* Wed Aug 26 2020 OSP Prod Chain <dev-null@redhat.com> 14.0.3-1
- Add silent flags to LB actions
- Fix ipv6 address pairs limits for ipv6 to 15
- Add silent flags to LB actions
- Fix ipv6 address pairs limits for ipv6 to 15

* Wed Aug 26 2020 OSP Prod Chain <dev-null@redhat.com> 14.0.3-1
- Update patches
- Add silent flags to LB actions

* Wed Aug 26 2020 OSP Prod Chain <dev-null@redhat.com> 14.0.3-1
- Update patches
- Fix ipv6 address pairs limits for ipv6 to 15

* Tue Aug 25 2020 OSP Prod Chain <dev-null@redhat.com> 14.0.3-1
- Update patches
- Add api to get all MP tier0 uplink ports

* Sun Aug 23 2020 OSP Prod Chain <dev-null@redhat.com> 14.0.3-1
- Update patches
- Add stale revision retry on policy update calls (using PATCH)

* Sun Aug 23 2020 OSP Prod Chain <dev-null@redhat.com> 14.0.3-1
- Update patches
- Add retry on StaleRevision for transactions

* Sun Aug 16 2020 OSP Prod Chain <dev-null@redhat.com> 14.0.3-1
- Update patches
- Add constant for ipv6 address pairs

* Sun Aug 09 2020 OSP Prod Chain <dev-null@redhat.com> 14.0.3-1
- Update patches
- Reduce client & cluster logs upon requests

* Thu Aug 06 2020 OSP Prod Chain <dev-null@redhat.com> 14.0.3-1
- Update patches
- Add silent param for lb stats

* Tue Jul 28 2020 OSP Prod Chain <dev-null@redhat.com> 14.0.3-1
- Update patches
- Improve security policy update rules with transactions

* Tue Jul 21 2020 OSP Prod Chain <dev-null@redhat.com> 14.0.3-1
- Update patches
- Add api for waiting for success consolidated status for gateway policy

* Tue Jul 21 2020 OSP Prod Chain <dev-null@redhat.com> 14.0.3-1
- Update patches

* Mon Jul 20 2020 OSP Prod Chain <dev-null@redhat.com> 14.0.3-1
- Update patches
- Handle icmp type 0 validation correctly

* Fri Jul 17 2020 OSP Prod Chain <dev-null@redhat.com> 14.0.3-1
- Update patches
- Revert "Improve security policy update rules with transactions"

* Thu Jul 16 2020 OSP Prod Chain <dev-null@redhat.com> 14.0.3-1
- Update patches
- Add wait_until_realized for security policies
- Fix get_firewall_section_id to return a valid section

* Mon Jun 29 2020 OSP Prod Chain <dev-null@redhat.com> 14.0.3-1
- Update patches
- Add getter for router BGP neighbors
- Add new certificate api find_cert_with_pem

* Mon Jun 29 2020 OSP Prod Chain <dev-null@redhat.com> 14.0.3-1
- Update patches
- Improve security policy update rules with transactions

* Mon Jun 29 2020 OSP Prod Chain <dev-null@redhat.com> 14.0.3-1
- Update patches
- Add uri_segment to NsxLibTrustManagement class

* Thu Jun 11 2020 OSP Prod Chain <dev-null@redhat.com> 14.0.3-1
- Update patches
- New api to get policy edge cluster nsx node ids

* Tue Jun 09 2020 OSP Prod Chain <dev-null@redhat.com> 14.0.3-1
- Update patches

* Mon Jun 08 2020 OSP Prod Chain <dev-null@redhat.com> 14.0.3-1
- Update patches
- Support segment profiles mapping

* Sun Jun 07 2020 OSP Prod Chain <dev-null@redhat.com> 14.0.3-1
- Update patches
- Add feature for supporting spoofguard ipv4 CIDR

* Fri May 29 2020 OSP Prod Chain <dev-null@redhat.com> 14.0.3-1
- Update patches
- Add mp api to list router static routes

* Thu May 28 2020 OSP Prod Chain <dev-null@redhat.com> 14.0.3-1
- Update patches
- Support LB rule changes by name suffix

* Thu May 28 2020 OSP Prod Chain <dev-null@redhat.com> 14.0.3-1
- Update patches
- Add api to get the shorten uuid suffix of resources names utility

* Thu May 21 2020 OSP Prod Chain <dev-null@redhat.com> 14.0.3-1
- Update patches
- Support dictionary subnets in segments

* Mon May 18 2020 OSP Prod Chain <dev-null@redhat.com> 14.0.3-1
- Update patches
- Support customized update of Policy LB service

* Thu May 14 2020 OSP Prod Chain <dev-null@redhat.com> 14.0.3-1
- Update patches
- Add silent flag to policy LB resources get api

* Tue May 05 2020 OSP Prod Chain <dev-null@redhat.com> 14.0.3-1
- Update patches
- Fix Train branch tox deps

* Thu Apr 16 2020 OSP Prod Chain <dev-null@redhat.com> 14.0.3-1
- Update patches
- Add api to remove segment tier1 connectivity

* Sun Apr 05 2020 OSP Prod Chain <dev-null@redhat.com> 14.0.3-1
- Update patches
- Add retry on StaleRevision errors for PATCH

* Mon Mar 30 2020 OSP Prod Chain <dev-null@redhat.com> 14.0.3-1
- Update patches
- Fix new StaleRevision exception

* Thu Mar 26 2020 OSP Prod Chain <dev-null@redhat.com> 14.0.3-1
- Update patches
- Fix segment port attach & detach

* Sun Mar 22 2020 OSP Prod Chain <dev-null@redhat.com> 14.0.3-1
- Update patches
- Add new StaleRevision error

* Thu Mar 12 2020 OSP Prod Chain <dev-null@redhat.com> 14.0.3-1
- Update patches
- Add another error_code for StaleRevision error

* Thu Mar 12 2020 OSP Prod Chain <dev-null@redhat.com> 14.0.3-1
- Update patches
- Use PUT instead of PATCH for segment port detach

* Wed Mar 11 2020 OSP Prod Chain <dev-null@redhat.com> 14.0.3-1
- Update patches
- Add nsx version 310

* Sun Mar 01 2020 OSP Prod Chain <dev-null@redhat.com> 14.0.3-1
- Update patches
- Fix firewall section add rule/s retry

* Thu Feb 27 2020 OSP Prod Chain <dev-null@redhat.com> 14.0.3-1
- Update patches
- Add support for policy DHCP v6

* Sun Feb 23 2020 OSP Prod Chain <dev-null@redhat.com> 14.0.3-1
- Update patches
- Set empty values in segment subnet when not set

* Fri Feb 21 2020 OSP Prod Chain <dev-null@redhat.com> 14.0.3-1
- Update patches
- Fix transport zones extraction from the transport node
- Retry all delete calles on StaleRevision exception

* Tue Feb 18 2020 OSP Prod Chain <dev-null@redhat.com> 14.0.3-1
- Update patches
- Fix segment PATCH data

* Tue Feb 11 2020 OSP Prod Chain <dev-null@redhat.com> 14.0.3-1
- Update patches
- Remove misplaced admin_state check

* Mon Feb 10 2020 OSP Prod Chain <dev-null@redhat.com> 14.0.3-1
- Update patches
- Refactor version dependant attributes in policy

* Thu Feb 06 2020 OSP Prod Chain <dev-null@redhat.com> 14.0.3-1
- Update patches
- Retry on internal server error 98

* Thu Jan 30 2020 OSP Prod Chain <dev-null@redhat.com> 14.0.3-1
- Update patches
- Updating segment port with empty attachment type

* Wed Jan 29 2020 OSP Prod Chain <dev-null@redhat.com> 14.0.3-1
- Update patches
- Update supported NSX version for relax_scale_validation

* Wed Jan 29 2020 OSP Prod Chain <dev-null@redhat.com> 14.0.3-1
- Update patches
- Support policy segment & port admin state

* Sun Jan 19 2020 OSP Prod Chain <dev-null@redhat.com> 14.0.3-1
- Update patches
- Add policy DHCP related resources support

* Sun Jan 12 2020 OSP Prod Chain <dev-null@redhat.com> 14.0.3-1
- Update patches
- Also call the superclass's tearDown() method when overriding it

* Wed Jan 08 2020 OSP Prod Chain <dev-null@redhat.com> 14.0.3-1
- Update patches

* Wed Jan 08 2020 OSP Prod Chain <dev-null@redhat.com> 14.0.3-1
- Update patches

* Thu Dec 26 2019 OSP Prod Chain <dev-null@redhat.com> 14.0.3-1
- Update patches
- Use updated search api path for version 3 & up

* Wed Dec 18 2019 OSP Prod Chain <dev-null@redhat.com> 14.0.3-1
- Update patches
- Allow updating NAT rule firewall_match field
- Fix test pep8 issue

* Thu Dec 12 2019 OSP Prod Chain <dev-null@redhat.com> 14.0.3-1
- Update patches

* Thu Dec 05 2019 OSP Prod Chain <dev-null@redhat.com> 14.0.3-1
- Update patches
- Remove recursive call in _proxy

* Tue Dec 03 2019 OSP Prod Chain <dev-null@redhat.com> 14.0.3-1
- Update patches
- Api for searching resource path by its realized type and id
- Merge "Add search index out of sync exception" into stable/train
- Merge "Support policy ipv6 routing via global config" into stable/train
- Add search index out of sync exception
- Support policy ipv6 routing via global config

* Mon Dec 02 2019 OSP Prod Chain <dev-null@redhat.com> 14.0.3-1
- Update patches
- Fix policy tier1 get_realized_id bug

* Mon Nov 25 2019 OSP Prod Chain <dev-null@redhat.com> 14.0.3-1
- Update patches
- Support transaction for Tier1 NAT rules create & delete

* Mon Nov 11 2019 OSP Prod Chain <dev-null@redhat.com> 14.0.3-1
- Update patches
- Add transaction support in SecurityPolicies and Rules

* Sun Nov 03 2019 OSP Prod Chain <dev-null@redhat.com> 14.0.3-1
- Update patches
- Merge "Fix policy LB member deletion" into stable/train
- Fix policy LB member deletion

* Sun Nov 03 2019 OSP Prod Chain <dev-null@redhat.com> 14.0.3-1
- Update patches
- Fix few policy transactions issues

* Tue Oct 29 2019 OSP Prod Chain <dev-null@redhat.com> 14.0.3-1
- Update patches
- Find OverlayTransportZone from host switch

* Sun Oct 27 2019 OSP Prod Chain <dev-null@redhat.com> 14.0.3-1
- Find tier0's tranzport_zone via advanced_config
- Fix policy tier1 get_realized_id bug
- Fix .gitreview for stable branch
- Find tier0's tranzport_zone via advanced_config
- Fix policy tier1 get_realized_id bug

* Thu Oct 24 2019 OSP Prod Chain <dev-null@redhat.com> 14.0.3-1
- Update patches
- Find tier0's tranzport_zone via advanced_config

* Tue Oct 22 2019 OSP Prod Chain <dev-null@redhat.com> 14.0.3-1
- Update patches
- Fix policy tier1 get_realized_id bug

* Mon Oct 14 2019 OSP Prod Chain <dev-null@redhat.com> 14.0.3-1
- Update patches
- Add caching for mdproxy & edge clusters for TZ validations
- Add VPN TODO

* Thu Oct 10 2019 OSP Prod Chain <dev-null@redhat.com> 14.0.3-1
- Update patches
- Include error code in RealizationErrorStateError in Policy

* Tue Oct 08 2019 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- Merge "Use realization ID if not found by search api"
- Merge "Add support for policy Metadata proxy resource"
- Add support for policy Metadata proxy resource
- Use realization ID if not found by search api

* Fri Oct 04 2019 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- Merge "Add exception for vlan conflicts"
- Add exception for vlan conflicts
- Add retry upon LB virtual server update conflicts


